VERSION 5.00
Begin VB.Form SelDir 
   Caption         =   "Select A Directory"
   ClientHeight    =   3495
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5040
   LinkTopic       =   "Form2"
   ScaleHeight     =   3495
   ScaleWidth      =   5040
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3840
      TabIndex        =   6
      Top             =   600
      Width           =   1095
   End
   Begin VB.CheckBox chkCancel 
      Caption         =   "Cancelled"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   3720
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.CommandButton cmdMkDir 
      Caption         =   "New Dir"
      Height          =   375
      Left            =   2640
      TabIndex        =   4
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3840
      TabIndex        =   3
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox DirName 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "You can either use the selectors below, or just type a directory name into this box."
      Top             =   120
      Width           =   3615
   End
   Begin VB.DirListBox Dir1 
      Height          =   2340
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   4815
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   2415
   End
End
Attribute VB_Name = "SelDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Copyright 2000, Charles Severance - All Rights Reserved
'
' This software is AS IS with no warranty
'

Dim SaveWidth As Integer
Dim SaveFormHeight As Integer
Dim SaveDir1Height As Integer

Private Sub cmdCancel_Click()
  DirName.Text = ""
  chkCancel.Value = 1
  SelDir.Hide
End Sub

Private Sub cmdMkdir_Click()
    Dim NewDir As String
    
    NewDir = InputBox("Enter New Directory", "Creating Directory", DirName.Text)
    If Len(Trim(NewDir)) = 0 Then
        Exit Sub
    End If
    Debug.Print "Creating ", NewDir
    If CRS_Mkdir(NewDir) Then
        DirName.Text = NewDir
        Dir1.Path = NewDir
    End If
End Sub

Private Sub cmdOK_Click()
  DirName.Text = Trim(DirName.Text)
  If Right(DirName.Text, 1) <> "\" Then
    DirName.Text = DirName.Text & "\"
  End If
  chkCancel.Value = 0
  SelDir.Hide
End Sub

Private Sub Dir1_Change()
  DirName.Text = Dir1.Path
  Debug.Print "In SelDir "; DirName.Text
End Sub

' For some reason this does not work

Private Sub Dir1_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        Dir1_Change
    End If
End Sub

Private Sub Drive1_Change()
   Dir1.Path = Drive1.Drive
End Sub

Private Sub Form_Activate()
  '  We must save the name, because once the drive changes,
  '  DirName.Text will be altered by the OnCHange method of the drive
  Dim SaveName As String
  Debug.Print "Activating SelDir ", DirName.Text
  SaveName = CRS_FixDirName(DirName.Text)
  If SaveName <> "" Then
    On Error Resume Next
    If Mid(SaveName, 2, 1) = ":" Then
      On Error Resume Next
      Drive1.Drive = Mid(SaveName, 1, 2)
      If Err.Number <> 0 Then
        MsgBox ("Error - Drive Letter wrong - " & DirName.Text)
        On Error GoTo 0
        Exit Sub
      End If
    End If
    If Not CRS_ChkDir(SaveName) Then
        If cmdMkDir.Visible Then
            If Not CRS_Mkdir(SaveName) Then
                '  Just drop through for now
            End If
        End If
    End If
    Dir1.Path = SaveName
    If Err Then
      MsgBox "Directory Not Found " & DirName.Text
      Dir1.Path = "C:\"
      Drive1.Drive = "C:\"
      DirName.Text = "C:\"
    End If
    On Error GoTo 0
  End If
End Sub

Public Sub Allow_Create()
    cmdMkDir.Visible = True
    Drive1.Width = SaveWidth
End Sub

' By Default we don't allow creation

Private Sub Form_Load()
    SaveFormHeight = SelDir.Height
    SaveDir1Height = Dir1.Height

    SaveWidth = Drive1.Width
    cmdMkDir.Visible = False
    Drive1.Width = (cmdMkDir.Left + cmdMkDir.Width) - Drive1.Left
    chkCancel.Value = 1   ' By default we were cancelled

End Sub

Private Sub Form_Resize()
    Dim NewHeight As Integer
    
    NewHeight = SelDir.Height - SaveFormHeight + SaveDir1Height
    If NewHeight > 100 Then Dir1.Height = NewHeight

End Sub
