Attribute VB_Name = "CRSString"
'
' Copyright 2000, Charles Severance - All Rights Reserved
'
' This software is AS IS with no warranty
'

Public Sub RepStr(OldPat As String, NewPat As String, OldString As String, NewString As String)
  Dim Pos As Integer
  Dim TmpString As String
  
' Debug.Print "OLD:", OldString
  NewString = OldString
  TmpString = OldString
  Pos = 1
  Do   'Replacing RepOld With RepNew
    Pos = InStr(Pos, TmpString, OldPat)
    If Pos = 0 Then Exit Do
    NewString = Left(TmpString, Pos - 1) & NewPat & Mid(TmpString, Pos + Len(OldPat))
    Pos = Pos + Len(NewPat) + 1
    TmpString = NewString
  Loop
' Debug.Print "NEW:", NewString

End Sub

Sub Split(InpString As String, SplitString() As String, N As Integer, Optional Delim As String)


    Dim LocalDelim As String
    
    Dim J As Integer
    Dim OldString As String
    
    If IsMissing(Delim) Then
        LocalDelim = " "
    Else
        LocalDelim = Left(Delim, 1)
        If LocalDelim = "" Then LocalDelim = " "
    End If
    
    OldString = Trim(InpString)
    N = 0
    Do While Len(OldString) > 0
      J = InStr(1, OldString, LocalDelim)
      N = N + 1
      If J = 0 Then
        SplitString(N) = Trim(OldString)
        OldString = ""
      Else
        SplitString(N) = Left(OldString, J - 1)
        OldString = Trim(Mid(OldString, J + 1))
      End If
'      Debug.Print N; "="; SplitString(N)
    Loop
End Sub


' CRS_LineInput - Read files fomr Mac, UNIX, or Windows - be real mellow
'   regarding end-lines
' Assumes file is open

Sub CRS_LineInput(IndNum As Integer, InputStr As String)
    Dim I As Integer
    Dim Ch As String
    Dim IsSpace As Boolean
    Dim IsNewLine As Boolean
    
    InputStr = ""
    If EOF(IndNum) Then
        Exit Sub
    End If
    I = 0 ' How many characters do we have
    On Error Resume Next
    Err.Clear
    While Err.Number = 0
        Ch = Input(1, #IndNum)
        If Err.Number <> 0 Then
            Exit Sub
        End If
    
        IsNewLine = Mid(Ch, 1, 1) = Chr(10) Or Mid(Ch, 1, 1) = Chr(13)
        IsSpace = Mid(Ch, 1, 1) = " " Or Mid(Ch, 1, 1) = Chr(9)
        
        If I = 0 And (IsNewLine Or IsSpace) Then
            ' Don't append - skip white space non-printing and new lines
        Else
            If IsNewLine Then ' Don't append, all done
                Exit Sub
            End If
            ' Finally, we append the string
            InputStr = InputStr & Ch
            I = I + 1
        End If
    Wend
End Sub


